AbstractLauncher.ServiceState (Apache Geode 1.13.3)
Date: 2021-06-22

org.apache.geode.distributed

## Class AbstractLauncher.ServiceState<T extends Comparable<T>>

- java.lang.Object
- - org.apache.geode.distributed.AbstractLauncher.ServiceState<T>

- Direct Known Subclasses:
    LocatorLauncher.LocatorState, ServerLauncher.ServerState
  Enclosing class:
    AbstractLauncher<T extends Comparable<T>>

      public abstract static class AbstractLauncher.ServiceState<T extends Comparable<T>>
      extends Object

  The ServiceState is an immutable type representing the state of the specified Locator at any given moment in time. The ServiceState associates the Locator with it's state at the exact moment an instance of this class is constructed.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `JSON_CLASSPATH`
    `protected static String` | `JSON_GEMFIREVERSION`
    `protected static String` | `JSON_HOST`
    `protected static String` | `JSON_JAVAVERSION`
    `protected static String` | `JSON_JVMARGUMENTS`
    `protected static String` | `JSON_LOCATION`
    `protected static String` | `JSON_LOGFILE`
    `protected static String` | `JSON_MEMBERNAME`
    `protected static String` | `JSON_PID`
    `protected static String` | `JSON_PORT`
    `protected static String` | `JSON_STATUS`
    `protected static String` | `JSON_STATUSMESSAGE`
    `protected static String` | `JSON_TIMESTAMP`
    `protected static String` | `JSON_UPTIME`
    `protected static String` | `JSON_WORKINGDIRECTORY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ServiceState(AbstractLauncher.Status status, String statusMessage, long timestamp, String serviceLocation, Integer pid, Long uptime, String workingDirectory, List<String> jvmArguments, String classpath, String gemfireVersion, String javaVersion, String logFile, String host, String port, String memberName)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static String` | `format(Date timestamp)`
    `String` | `getClasspath()` Gets the Java classpath used when launching the GemFire service.
    `String` | `getGemFireVersion()` Gets the version of GemFire used to launch and run the GemFire service.
    `String` | `getHost()` Gets the host or IP address for the process and its service.
    `String` | `getJavaVersion()` Gets the version of Java used to launch and run the GemFire service.
    `List<String>` | `getJvmArguments()` Gets the arguments passed to the JVM process that is running the GemFire service.
    `String` | `getLogFile()` Gets the path of the log file for the process.
    `String` | `getMemberName()` Gets GemFire member's name for the process.
    `Integer` | `getPid()` Gets the process ID of the running GemFire service if known, otherwise returns null.
    `String` | `getPort()` Gets the port for the process and its service.
    `String` | `getServiceLocation()` Gets the location of the GemFire service (usually the host in combination with the port).
    `protected abstract String` | `getServiceName()` Gets the name of the GemFire service.
    `AbstractLauncher.Status` | `getStatus()` Gets the state of the GemFire service.
    `String` | `getStatusMessage()` Gets description of the the service's current state.
    `Timestamp` | `getTimestamp()` The date and time the GemFire service was last in this state.
    `Long` | `getUptime()` Gets the amount of time in milliseconds that the JVM process with the GemFire service has been running.
    `String` | `getWorkingDirectory()` Gets the directory in which the GemFire service is running.
    `protected static Integer` | `identifyPid()`
    `static boolean` | `isStartingNotRespondingOrNull(AbstractLauncher.ServiceState serviceState)`
    `boolean` | `isStartingOrNotResponding()`
    `boolean` | `isVmWithProcessIdRunning()`
    `protected static String` | `toDaysHoursMinutesSeconds(Long milliseconds)`
    `String` | `toJson()` Marshals this state object into a JSON String.
    `String` | `toString()` Gets a String describing the state of the GemFire service.
    `protected String` | `toString(Date dateTime)`
    `protected String` | `toString(Number value)`
    `protected String` | `toString(Object... values)`
    `protected String` | `toString(String value)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### JSON_CLASSPATH

          protected static final String JSON_CLASSPATH

      See Also:
        Constant Field Values

    - #### JSON_GEMFIREVERSION

          protected static final String JSON_GEMFIREVERSION

      See Also:
        Constant Field Values

    - #### JSON_HOST

          protected static final String JSON_HOST

      See Also:
        Constant Field Values

    - #### JSON_JAVAVERSION

          protected static final String JSON_JAVAVERSION

      See Also:
        Constant Field Values

    - #### JSON_JVMARGUMENTS

          protected static final String JSON_JVMARGUMENTS

      See Also:
        Constant Field Values

    - #### JSON_LOCATION

          protected static final String JSON_LOCATION

      See Also:
        Constant Field Values

    - #### JSON_LOGFILE

          protected static final String JSON_LOGFILE

      See Also:
        Constant Field Values

    - #### JSON_MEMBERNAME

          protected static final String JSON_MEMBERNAME

      See Also:
        Constant Field Values

    - #### JSON_PID

          protected static final String JSON_PID

      See Also:
        Constant Field Values

    - #### JSON_PORT

          protected static final String JSON_PORT

      See Also:
        Constant Field Values

    - #### JSON_STATUS

          protected static final String JSON_STATUS

      See Also:
        Constant Field Values

    - #### JSON_STATUSMESSAGE

          protected static final String JSON_STATUSMESSAGE

      See Also:
        Constant Field Values

    - #### JSON_TIMESTAMP

          protected static final String JSON_TIMESTAMP

      See Also:
        Constant Field Values

    - #### JSON_UPTIME

          protected static final String JSON_UPTIME

      See Also:
        Constant Field Values

    - #### JSON_WORKINGDIRECTORY

          protected static final String JSON_WORKINGDIRECTORY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ServiceState

          protected ServiceState(AbstractLauncher.Status status,
                                 String statusMessage,
                                 long timestamp,
                                 String serviceLocation,
                                 Integer pid,
                                 Long uptime,
                                 String workingDirectory,
                                 List<String> jvmArguments,
                                 String classpath,
                                 String gemfireVersion,
                                 String javaVersion,
                                 String logFile,
                                 String host,
                                 String port,
                                 String memberName)

  - ### Method Detail

    - #### format

          protected static String format(Date timestamp)

    - #### identifyPid

          protected static Integer identifyPid()

    - #### toDaysHoursMinutesSeconds

          protected static String toDaysHoursMinutesSeconds(Long milliseconds)

    - #### toJson

          public String toJson()

      Marshals this state object into a JSON String.
      Returns:
        a String value containing the JSON representation of this state object.

    - #### isStartingNotRespondingOrNull

          public static boolean isStartingNotRespondingOrNull(AbstractLauncher.ServiceState serviceState)

    - #### isStartingOrNotResponding

          public boolean isStartingOrNotResponding()

    - #### isVmWithProcessIdRunning

          public boolean isVmWithProcessIdRunning()

    - #### getClasspath

          public String getClasspath()

      Gets the Java classpath used when launching the GemFire service.
      Returns:
        a String value indicating the Java classpath used when launching the GemFire service.
      See Also:
        `with 'java.class.path'`

    - #### getGemFireVersion

          public String getGemFireVersion()

      Gets the version of GemFire used to launch and run the GemFire service.
      Returns:
        a String indicating the version of GemFire used in the running GemFire service.

    - #### getJavaVersion

          public String getJavaVersion()

      Gets the version of Java used to launch and run the GemFire service.
      Returns:
        a String indicating the version of the Java runtime used in the running GemFire service.
      See Also:
        `with 'java.verson'`

    - #### getJvmArguments

          public List<String> getJvmArguments()

      Gets the arguments passed to the JVM process that is running the GemFire service.
      Returns:
        a List of String value each representing an argument passed to the JVM of the GemFire service.
      See Also:
        `RuntimeMXBean.getInputArguments()`

    - #### getMemberName

          public String getMemberName()

      Gets GemFire member's name for the process.
      Returns:
        a String indicating the GemFire member's name for the process.

    - #### getPid

          public Integer getPid()

      Gets the process ID of the running GemFire service if known, otherwise returns null.
      Returns:
        a integer value indicating the process ID (PID) of the running GemFire service, or null if the PID cannot be determined.

    - #### getServiceLocation

          public String getServiceLocation()

      Gets the location of the GemFire service (usually the host in combination with the port).
      Returns:
        a String indication the location (such as host/port) of the GemFire service.

    - #### getServiceName

          protected abstract String getServiceName()

      Gets the name of the GemFire service.
      Returns:
        a String indicating the name of the GemFire service.

    - #### getStatus

          public AbstractLauncher.Status getStatus()

      Gets the state of the GemFire service.
      Returns:
        a Status enumerated type representing the state of the GemFire service.
      See Also:
        `AbstractLauncher.Status`

    - #### getStatusMessage

          public String getStatusMessage()

      Gets description of the the service's current state.
      Returns:
        a String describing the service's current state.

    - #### getTimestamp

          public Timestamp getTimestamp()

      The date and time the GemFire service was last in this state.
      Returns:
        a Timestamp signifying the last date and time the GemFire service was in this state.
      See Also:
        `Timestamp`

    - #### getUptime

          public Long getUptime()

      Gets the amount of time in milliseconds that the JVM process with the GemFire service has been running.
      Returns:
        a long value indicating the number of milliseconds that the GemFire service JVM has been running.
      See Also:
        `RuntimeMXBean.getUptime()`

    - #### getWorkingDirectory

          public String getWorkingDirectory()

      Gets the directory in which the GemFire service is running. This is also the location where all GemFire service files (log files, the PID file, and so on) are written.
      Returns:
        a String value indicating the GemFire service's working (running) directory.

    - #### getLogFile

          public String getLogFile()

      Gets the path of the log file for the process.
      Returns:
        a String value indicating the path of the log file for the process.

    - #### getHost

          public String getHost()

      Gets the host or IP address for the process and its service.
      Returns:
        a String value representing the host or IP address for the process and its service.

    - #### getPort

          public String getPort()

      Gets the port for the process and its service.
      Returns:
        an Integer value indicating the port for the process and its service.

    - #### toString

          public String toString()

      Gets a String describing the state of the GemFire service.
      Overrides:
        `toString` in class `Object`
      Returns:
        a String describing the state of the GemFire service.

    - #### toString

          protected String toString(Date dateTime)

    - #### toString

          protected String toString(Number value)

    - #### toString

          protected String toString(Object... values)

    - #### toString

          protected String toString(String value)